unit ent_cities;

interface

uses
  SysUtils, 
  Generics.Collections, 
  Aurelius.Mapping.Attributes, 
  Aurelius.Types.Blob, 
  Aurelius.Types.DynamicProperties, 
  Aurelius.Types.Nullable, 
  Aurelius.Types.Proxy, 
  Aurelius.Dictionary.Classes, 
  Aurelius.Linq;

type
  TCities = class;
  TCitiesDictionary = class;
  
  [Entity]
  [Table('Cities', 'db-b')]
  [Id('Fid', TIdGenerator.IdentityOrSequence)]
  TCities = class
  private
    [Column('id', [TColumnProp.Required, TColumnProp.NoInsert, TColumnProp.NoUpdate])]
    Fid: Integer;
    
    [Column('CityName', [TColumnProp.Required], 31)]
    FCityName: string;
  public
    property id: Integer read Fid write Fid;
    property CityName: string read FCityName write FCityName;
  end;
  
  ICitiesDictionary = interface;
  
  ICitiesDictionary = interface(IAureliusEntityDictionary)
    function id: TLinqProjection;
    function CityName: TLinqProjection;
  end;
  
  TCitiesDictionary = class(TAureliusEntityDictionary, ICitiesDictionary)
  public
    function id: TLinqProjection;
    function CityName: TLinqProjection;
  end;
  
  IDictionary = interface(IAureliusDictionary)
    function Cities: ICitiesDictionary;
  end;
  
  TDictionary = class(TAureliusDictionary, IDictionary)
  public
    function Cities: ICitiesDictionary;
  end;
  
function Dic: IDictionary;

implementation

var
  __Dic: IDictionary;

function Dic: IDictionary;
begin
  if __Dic = nil then __Dic := TDictionary.Create;
  result := __Dic;
end;

{ TCitiesDictionary }

function TCitiesDictionary.id: TLinqProjection;
begin
  Result := Prop('id');
end;

function TCitiesDictionary.CityName: TLinqProjection;
begin
  Result := Prop('CityName');
end;

{ TDictionary }

function TDictionary.Cities: ICitiesDictionary;
begin
  Result := TCitiesDictionary.Create;
end;

initialization
  RegisterEntity(TCities);

end.
